

jQuery(document).ready(function() {
	
	var modules = [simple_module];
	
	var onTransactionsReceived = function(transactions, input) {
		// Clear all existing modules
		jQuery("#modules").empty();
		
		// Create new modules
		modules.forEach(function (module) {
			module(transactions, input);
		});
	}
	
	var onInputSend = function(input) {
		var onFileLoaded = function() {
			var rawCSVText = reader.result;
			var transactions = d3
				.csvParse(rawCSVText)
				.map(input.mapper)
				.sort(function (t1,t2) { return t1.date - t2.date })
				.filter(function(t) { return t.date >= input.startDate && t.date <= input.endDate });
				
			onTransactionsReceived(transactions, input);
		};
		
		var reader = new FileReader();
		reader.addEventListener("load", onFileLoaded, false);
		reader.readAsText(input.file);
	};
	
	initializeInput();
	bindChangingInput(onInputSend);
	
});